/* See license.txt for terms of usage */
/*
 * Text diff implementation.
 *
 * This library supports the following APIS:
 * JsDiff.diffChars: Character by character diff
 * JsDiff.diffWords: Word (as defined by \b regex) diff which ignores whitespace
 * JsDiff.diffLines: Line based diff
 *
 * JsDiff.diffCss: Diff targeted at CSS content
 *
 * These methods are based on the implementation proposed in
 * "An O(ND) Difference Algorithm and its Variations" (Myers, 1986).
 * http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.4.6927
 */
var JsDiff=function(){function e(e){return{newPos:e.newPos,components:e.components.slice(0)}}function t(e){var t=[];for(var n=0;n<e.length;n++)e[n]&&t.push(e[n]);return t}function n(e){var t=e;return t=t.replace(/&/g,"&amp;"),t=t.replace(/</g,"&lt;"),t=t.replace(/>/g,"&gt;"),t=t.replace(/"/g,"&quot;"),t}var r=function(e){this.ignoreWhitespace=e};r.prototype={diff:function(t,n){if(n==t)return[{value:n}];if(!n)return[{value:t,removed:!0}];if(!t)return[{value:n,added:!0}];n=this.tokenize(n),t=this.tokenize(t);var r=n.length,i=t.length,s=r+i,o=[{newPos:-1,components:[]}],u=this.extractCommon(o[0],n,t,0);if(o[0].newPos+1>=r&&u+1>=i)return o[0].components;for(var a=1;a<=s;a++)for(var f=-1*a;f<=a;f+=2){var l,c=o[f-1],h=o[f+1];u=(h?h.newPos:0)-f,c&&(o[f-1]=undefined);var p=c&&c.newPos+1<r,d=h&&0<=u&&u<i;if(!p&&!d){o[f]=undefined;continue}!p||d&&c.newPos<h.newPos?(l=e(h),this.pushComponent(l.components,t[u],undefined,!0)):(l=e(c),l.newPos++,this.pushComponent(l.components,n[l.newPos],!0,undefined));var u=this.extractCommon(l,n,t,f);if(l.newPos+1>=r&&u+1>=i)return l.components;o[f]=l}},pushComponent:function(e,t,n,r){var i=e[e.length-1];i&&i.added===n&&i.removed===r?e[e.length-1]={value:this.join(i.value,t),added:n,removed:r}:e.push({value:t,added:n,removed:r})},extractCommon:function(e,t,n,r){var i=t.length,s=n.length,o=e.newPos,u=o-r;while(o+1<i&&u+1<s&&this.equals(t[o+1],n[u+1]))o++,u++,this.pushComponent(e.components,t[o],undefined,undefined);return e.newPos=o,u},equals:function(e,t){var n=/\S/;return this.ignoreWhitespace&&!n.test(e)&&!n.test(t)?!0:e==t},join:function(e,t){return e+t},tokenize:function(e){return e}};var i=new r,s=new r(!0);s.tokenize=function(e){return t(e.split(/(\s+|\b)/))};var o=new r(!0);o.tokenize=function(e){return t(e.split(/([{}:;,]|\s+)/))};var u=new r;return u.tokenize=function(e){return e.split(/^/m)},{diffChars:function(e,t){return i.diff(e,t)},diffWords:function(e,t){return s.diff(e,t)},diffLines:function(e,t){return u.diff(e,t)},diffCss:function(e,t){return o.diff(e,t)},createPatch:function(e,t,n,r,i){function a(e){return e.map(function(e){return" "+e})}function f(e,t,n){var r=o[o.length-2],i=t===o.length-2,s=t===o.length-3&&(n.added===!r.added||n.removed===!r.removed);!/\n$/.test(n.value)&&(i||s)&&e.push("\\ No newline at end of file")}var s=[];s.push("Index: "+e),s.push("==================================================================="),s.push("--- "+e+(typeof r=="undefined"?"":"	"+r)),s.push("+++ "+e+(typeof i=="undefined"?"":"	"+i));var o=u.diff(t,n);o[o.length-1].value||o.pop(),o.push({value:"",lines:[]});var l=0,c=0,h=[],p=1,d=1;for(var v=0;v<o.length;v++){var m=o[v],g=m.lines||m.value.replace(/\n$/,"").split("\n");m.lines=g;if(m.added||m.removed){if(!l){var y=o[v-1];l=p,c=d,y&&(h=a(y.lines.slice(-4)),l-=h.length,c-=h.length)}h.push.apply(h,g.map(function(e){return(m.added?"+":"-")+e})),f(h,v,m),m.added?d+=g.length:p+=g.length}else{if(l)if(g.length<=8&&v<o.length-2)h.push.apply(h,a(g));else{var b=Math.min(g.length,4);s.push("@@ -"+l+","+(p-l+b)+" +"+c+","+(d-c+b)+" @@"),s.push.apply(s,h),s.push.apply(s,a(g.slice(0,b))),g.length<=4&&f(s,v,m),l=0,c=0,h=[]}p+=g.length,d+=g.length}}return s.join("\n")+"\n"},convertChangesToXML:function(e){var t=[];for(var r=0;r<e.length;r++){var i=e[r];i.added?t.push("<ins>"):i.removed&&t.push("<del>"),t.push(n(i.value)),i.added?t.push("</ins>"):i.removed&&t.push("</del>")}return t.join("")},convertChangesToDMP:function(e){var t=[],n;for(var r=0;r<e.length;r++)n=e[r],t.push([n.added?1:n.removed?-1:0,n.value]);return t}}}();typeof module!="undefined"&&(module.exports=JsDiff);