/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
/*jslint browser: true, bitwise: false, plusplus: false */
/*global Util, Base64 */
// Load Flash WebSocket emulator if needed
function Websock(){"use strict";function a(){return s}function f(){return n}function l(){return r}function c(e){r=e}function h(){return n.length-r}function p(){return n[r]}function d(){return n[r++]}function v(e){r===0?n.unshift(e):(r-=1,n[r]=e)}function m(){return(n[r++]<<8)+n[r++]}function g(){return(n[r++]<<24)+(n[r++]<<16)+(n[r++]<<8)+n[r++]}function y(e){typeof e=="undefined"&&(e=h());var t=n.slice(r,r+e);return r+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function b(e){return typeof e=="undefined"&&(e=h()),r+=e,n.slice(r-e,r)}function w(e,t){return t?n.slice(r+e,r+t):n.slice(r+e)}function E(e,t,i){var s=n.length-r;if(s<t){if(i){if(r<i)throw"rQwait cannot backup "+i+" bytes";r-=i}return!0}return!1}function S(){return Base64.encode(s)}function x(e){n=n.concat(Base64.decode(e,0))}function T(){return t.bufferedAmount!==0&&Util.Debug("bufferedAmount: "+t.bufferedAmount),t.bufferedAmount<e.maxBufferedAmount?(s.length>0&&(t.send(S(s)),s=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+t.bufferedAmount),!1)}function N(e){return s=s.concat(e),T()}function C(t){e.send(t.split("").map(function(e){return e.charCodeAt(0)}))}function k(e){try{x(e.data),h()>0?(o.message(),n.length>i&&(n=n.slice(r),r=0)):Util.Debug("Ignoring empty message")}catch(t){typeof t.stack!="undefined"?Util.Warn("recv_message, caught exception: "+t.stack):typeof t.description!="undefined"?Util.Warn("recv_message, caught exception: "+t.description):Util.Warn("recv_message, caught exception:"+t),typeof t.name!="undefined"?o.error(t.name+": "+t.message):o.error(t)}}function L(e,t){o[e]=t}function A(){n=[],r=0,s=[],t=null}function O(e){A(),u?t={}:t=new WebSocket(e,"base64"),t.onmessage=k,t.onopen=function(){Util.Debug(">> WebSock.onopen"),t.protocol&&Util.Info("Server chose sub-protocol: "+t.protocol),o.open(),Util.Debug("<< WebSock.onopen")},t.onclose=function(e){Util.Debug(">> WebSock.onclose"),o.close(e),Util.Debug("<< WebSock.onclose")},t.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),o.error(e),Util.Debug("<< WebSock.onerror")}}function M(){if(t){if(t.readyState===WebSocket.OPEN||t.readyState===WebSocket.CONNECTING)Util.Info("Closing WebSocket connection"),t.close();t.onmessage=function(e){return}}}function _(t){return u=!0,e.send=t,e.close=function(){},k}function D(){return e.maxBufferedAmount=200,e.get_sQ=a,e.get_rQ=f,e.get_rQi=l,e.set_rQi=c,e.rQlen=h,e.rQpeek8=p,e.rQshift8=d,e.rQunshift8=v,e.rQshift16=m,e.rQshift32=g,e.rQshiftStr=y,e.rQshiftBytes=b,e.rQslice=w,e.rQwait=E,e.flush=T,e.send=N,e.send_string=C,e.on=L,e.init=A,e.open=O,e.close=M,e.testMode=_,e}var e={},t=null,n=[],r=0,i=1e4,s=[],o={message:function(){},open:function(){},close:function(){},error:function(){}},u=!1;return D()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return typeof INCLUDE_URI!="undefined"?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",r="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),r+=t+"web-socket-js/swfobject.js"+n,r+=t+"web-socket-js/web_socket.js"+n,document.write(r)}());