/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 *
 * TIGHT decoder portion:
 * (c) 2012 Michael Tinglof, Joe Balaz, Les Piech (Mercuri.ca)
 */
/*jslint white: false, browser: true, bitwise: false, plusplus: false */
/*global window, Util, Display, Keyboard, Mouse, Websock, Websock_native, Base64, DES */
function RFB(e){"use strict";function ut(){var e,u;Util.Debug(">> RFB.constructor");for(e=0;e<D.length;e+=1)P[D[e][1]]=P[D[e][0]],H[D[e][1]]=D[e][0],B[D[e][1]]=[0,0];try{F=new Display({target:n.target})}catch(a){Util.Error("Display exception: "+a),i("fatal","No working Display")}return I=new Keyboard({target:n.focusContainer,onKeyPress:E}),q=new Mouse({target:n.target,onMouseButton:S,onMouseMove:x}),u=F.get_render_mode(),j=new Websock,j.on("message",o),j.on("open",function(){A==="connect"?i("ProtocolVersion","Starting VNC handshake"):s("Got unexpected WebSockets connection")}),j.on("close",function(e){e.code&&Util.Info("Close code: "+e.code+", reason: "+e.reason+", wasClean: "+e.wasClean),A==="disconnect"?i("disconnected","VNC disconnected"):A==="ProtocolVersion"?s("Failed to connect to server"):A in{failed:1,disconnected:1}?Util.Error("Received onclose while disconnected"):s("Server disconnected")}),j.on("error",function(e){s("WebSock error: "+e)}),r(),Websock_native?(Util.Info("Using native WebSockets"),i("loaded","noVNC ready: native WebSockets, "+u)):(Util.Warn("Using web-socket-js bridge. Flash version: "+Util.Flash.version),!Util.Flash||Util.Flash.version<9?i("fatal","WebSockets or <a href='http://get.adobe.com/flashplayer'>Adobe Flash</a> is required"):document.location.href.substr(0,7)==="file://"?i("fatal","'file://' URL is incompatible with Adobe Flash"):i("loaded","noVNC ready: WebSockets emulation, "+u)),Util.Debug("<< RFB.constructor"),t}function at(){Util.Debug(">> RFB.connect");var e;typeof UsingSocketIO!="undefined"?e="http://"+N+":"+C+"/"+L:(n.encrypt?e="wss://":e="ws://",e+=N+":"+C+"/"+L),Util.Info("connecting to "+e),j.open(e),Util.Debug("<< RFB.connect")}function ft(e,t){var n,r=[];for(n=0;n<e.length;n+=1)r.push(e.charCodeAt(n));return(new DES(r)).encrypt(t)}function lt(){return it.length>0?(j.send(it),setTimeout(function(){j.send(d())},50),it=[],!0):!1}function ct(e){$===1&&s("Tight protocol handler only implements true color mode");var t,n,r,i,o,u,a=-1,f=0,l=-1,c=j.get_rQ(),h=j.get_rQi();X.bytes=1;if(j.rQwait("TIGHT compression-control",X.bytes))return!1;var p=function(e){var t=0,n;for(n=0;n<e.length;n++)t+=e[n],t>65536&&(t-=65536);return t},d=function(e){for(var t=0;t<4;t++)f>>t&1&&(X.zlibs[t].reset(),Util.Info("Reset zlib stream "+t));var n=X.zlibs[l].uncompress(e,0);return n.status!==0&&Util.Error("Invalid data in zlib stream"),n.data},v=function(){var e=c[h+2]+1,t=e*$;X.bytes+=t;if(j.rQwait("TIGHT palette "+n,X.bytes))return!1;var i=e<=2?1:8,s=Math.floor((X.width*i+7)/8),o=!1;s*X.height<12?(o=!0,r=[0,s*X.height]):r=y(j.rQslice(3+t,3+t+3)),X.bytes+=r[0]+r[1];if(j.rQwait("TIGHT "+n,X.bytes))return!1;j.rQshiftBytes(3);var a=j.rQshiftBytes(t);j.rQshiftBytes(r[0]),o?u=j.rQshiftBytes(r[1]):u=d(j.rQshiftBytes(r[1]));var f=[],l,p,v,m,g,b,w;if(e===2){m=Math.floor((X.width+7)/8),g=Math.floor(X.width/8);for(p=0;p<X.height;p++){for(l=0;l<g;l++)for(v=7;v>=0;v--)b=(p*X.width+l*8+7-v)*3,w=(u[p*m+l]>>v&1)*3,f[b]=a[w],f[b+1]=a[w+1],f[b+2]=a[w+2];for(v=7;v>=8-X.width%8;v--)b=(p*X.width+l*8+7-v)*3,w=(u[p*m+l]>>v&1)*3,f[b]=a[w],f[b+1]=a[w+1],f[b+2]=a[w+2]}}else for(p=0;p<X.height;p++)for(l=0;l<X.width;l++)b=(p*X.width+l)*3,w=u[p*X.width+l]*3,f[b]=a[w],f[b+1]=a[w+1],f[b+2]=a[w+2];return X.imgQ.push({type:"rgb",img:{complete:!0,data:f},x:X.x,y:X.y,width:X.width,height:X.height}),!0},m=function(){var e=!1,t=X.width*X.height*$;return t<12?(e=!0,r=[0,t]):r=y(j.rQslice(1,4)),X.bytes=1+r[0]+r[1],j.rQwait("TIGHT "+n,X.bytes)?!1:(j.rQshiftBytes(1+r[0]),e?u=j.rQshiftBytes(r[1]):u=d(j.rQshiftBytes(r[1])),X.imgQ.push({type:"rgb",img:{complete:!0,data:u},x:X.x,y:X.y,width:X.width,height:X.height}),!0)};t=j.rQpeek8(),f=t&15,t>>=4,l=t&3;if(t===8)n="fill";else if(t===9)n="jpeg";else if(t===10)n="png";else if(t&4)n="filter";else{if(!(t<4))throw"Illegal tight compression received, ctl: "+t;n="copy"}if(!e||n!=="filter"&&n!=="copy"){switch(n){case"fill":X.bytes+=$;break;case"jpeg":X.bytes+=3;break;case"png":X.bytes+=3;break;case"filter":X.bytes+=2;break;case"copy":}if(j.rQwait("TIGHT "+n,X.bytes))return!1;switch(n){case"fill":j.rQshift8(),i=j.rQshiftBytes($),X.imgQ.push({type:"fill",img:{complete:!0},x:X.x,y:X.y,width:X.width,height:X.height,color:[i[2],i[1],i[0]]});break;case"png":case"jpeg":r=y(j.rQslice(1,4)),X.bytes=1+r[0]+r[1];if(j.rQwait("TIGHT "+n,X.bytes))return!1;j.rQshiftBytes(1+r[0]),o=new Image,X.imgQ.push({type:"img",img:o,x:X.x,y:X.y}),o.src="data:image/"+n+b(j.rQshiftBytes(r[1])),o=null;break;case"filter":a=c[h+1];if(a!==1)throw"Unsupported tight subencoding received, filter: "+a;if(!v())return!1;break;case"copy":if(!m())return!1}return X.bytes=0,X.rects-=1,!0}throw"filter/copy received in tightPNG mode"}var t={},n={},r,i,s,o,u,a,f,l,c,h,p,d,v,m,g,y,b,w,E,S,x,T,N="",C=5900,k="",L="",A="disconnected",O=0,M=3.8,_="",D=[["COPYRECT",1],["TIGHT",7],["TIGHT_PNG",-260],["HEXTILE",5],["RRE",2],["RAW",0],["DesktopSize",-223],["Cursor",-239],["JPEG_quality_med",-26],["compress_hi",-247],["last_rect",-224]],P={},H={},B={},j=null,F=null,I=null,q=null,R=null,U=null,z=null,W=null,X={rects:0,subrects:0,lines:0,tiles:0,bytes:0,x:0,y:0,width:0,height:0,encoding:0,subencoding:-1,background:null,imgQ:[],zlibs:[]},V=4,$=3,J=0,K=0,Q="",G=40,Y=0,Z=100,et={last_fbu:0,fbu_total:0,fbu_total_cnt:0,full_fbu_total:0,full_fbu_cnt:0,fbu_rt_start:0,fbu_rt_total:0,fbu_rt_cnt:0,pixels:0},tt=!1,nt=Websock_native?10:25,rt=0,it=[],st=!1,ot={};return Util.conf_defaults(n,t,e,[["target","wo","dom",null,"VNC display rendering Canvas object"],["focusContainer","wo","dom",document,"DOM element that captures keyboard input"],["encrypt","rw","bool",!1,"Use TLS/SSL/wss encryption"],["true_color","rw","bool",!0,"Request true color pixel data"],["local_cursor","rw","bool",!1,"Request locally rendered cursor"],["shared","rw","bool",!0,"Request shared mode"],["view_only","rw","bool",!1,"Disable client mouse/keyboard"],["connectTimeout","rw","int",nt,"Time (s) to wait for connection"],["disconnectTimeout","rw","int",10,"Time (s) to wait for disconnection"],["viewportDrag","rw","bool",!1,"Move the viewport on mouse drags"],["check_rate","rw","int",217,"Timing (ms) of send/receive check"],["fbu_req_rate","rw","int",1413,"Timing (ms) of frameBufferUpdate requests"],["onUpdateState","rw","func",function(){},"onUpdateState(rfb, state, oldstate, statusMsg): RFB state update/change "],["onPasswordRequired","rw","func",function(){},"onPasswordRequired(rfb): VNC password is required "],["onClipboard","rw","func",function(){},"onClipboard(rfb, text): RFB clipboard contents received"],["onBell","rw","func",function(){},"onBell(rfb): RFB Bell message received "],["onFBUReceive","rw","func",function(){},"onFBUReceive(rfb, fbu): RFB FBU received but not yet processed "],["onFBUComplete","rw","func",function(){},"onFBUComplete(rfb, fbu): RFB FBU received and processed "],["updateState","rw","func",function(){},"obsolete, use onUpdateState"],["clipboardReceive","rw","func",function(){},"obsolete, use onClipboard"]]),t.set_local_cursor=function(e){!e||e in{0:1,no:1,"false":1}?n.local_cursor=!1:F.get_cursor_uri()?n.local_cursor=!0:Util.Warn("Browser does not support local cursor")},t.get_display=function(){return F},t.get_keyboard=function(){return I},t.get_mouse=function(){return q},r=function(){var e;j.init(),X.rects=0,X.subrects=0,X.lines=0,X.tiles=0,X.imgQ=[],X.zlibs=[],rt=0,it=[];for(e=0;e<D.length;e+=1)B[D[e][1]][0]=0;for(e=0;e<4;e++)X.zlibs[e]=new TINF,X.zlibs[e].init()},l=function(){var e,t;Util.Info("Encoding stats for this connection:");for(e=0;e<D.length;e+=1)t=B[D[e][1]],t[0]+t[1]>0&&Util.Info("    "+D[e][0]+": "+t[0]+" rects");Util.Info("Encoding stats since page load:");for(e=0;e<D.length;e+=1)t=B[D[e][1]],t[0]+t[1]>0&&Util.Info("    "+D[e][0]+": "+t[1]+" rects")},i=function(e,o){var u,a,f=A;if(e===f){Util.Debug("Already in state '"+e+"', ignoring.");return}e in{disconnected:1,loaded:1,connect:1,disconnect:1,failed:1,fatal:1}&&(R&&(clearInterval(R),R=null),W&&(clearInterval(W),W=null),F&&F.get_context()&&(I.ungrab(),q.ungrab(),F.defaultCursor(),(Util.get_logging()!=="debug"||e==="loaded")&&F.clear()),j.close()),f==="fatal"&&Util.Error("Fatal error, cannot continue"),e==="failed"||e==="fatal"?u=Util.Error:u=Util.Warn,f==="failed"&&e==="disconnected"?A="failed":A=e,a=typeof o!="undefined"?" Msg: "+o:"",u("New state '"+A+"', was '"+f+"'."+a),U&&A!=="connect"&&(Util.Debug("Clearing connect timer"),clearInterval(U),U=null),z&&A!=="disconnect"&&(Util.Debug("Clearing disconnect timer"),clearInterval(z),z=null);switch(e){case"normal":(f==="disconnected"||f==="failed")&&Util.Error("Invalid transition from 'disconnected' or 'failed' to 'normal'");break;case"connect":U=setTimeout(function(){s("Connect timeout")},n.connectTimeout*1e3),r(),at();break;case"disconnect":tt||(z=setTimeout(function(){s("Disconnect timeout")},n.disconnectTimeout*1e3)),l();break;case"failed":f==="disconnected"&&Util.Error("Invalid transition from 'disconnected' to 'failed'"),f==="normal"&&Util.Error("Error while connected."),f==="init"&&Util.Error("Error while initializing."),setTimeout(function(){i("disconnected")},50);break;default:}f==="failed"&&e==="disconnected"?(n.updateState(t,e,f),n.onUpdateState(t,e,f)):(n.updateState(t,e,f,o),n.onUpdateState(t,e,f,o))},s=function(e){return i("failed",e),!1},o=function(){if(j.rQlen()===0){Util.Warn("handle_message called on empty receive queue");return}switch(A){case"disconnected":case"failed":Util.Error("Got data while disconnected");break;case"normal":a()&&j.rQlen()>0&&(W===null?(Util.Debug("More data to process, creating timer"),W=setTimeout(function(){W=null,o()},10)):Util.Debug("More data to process, existing timer"));break;default:u()}},T=function(){var e;A==="normal"&&!st&&(lt()||(e=(new Date).getTime(),e>Y+n.fbu_req_rate&&(Y=e,j.send(d())))),setTimeout(T,n.check_rate)},E=function(e,t){var r;if(n.view_only)return;r=v(e,t),r=r.concat(d()),j.send(r)},S=function(e,t,r,i){r?rt|=i:rt^=i;if(n.viewportDrag){if(r&&!st){st=!0,ot={x:e,y:t};return}st=!1,j.send(d())}if(n.view_only)return;it=it.concat(m(F.absX(e),F.absY(t))),lt()},x=function(e,t){var r,i;if(st){r=ot.x-e,i=ot.y-t,ot={x:e,y:t},F.viewportChange(r,i);return}if(n.view_only)return;it=it.concat(m(F.absX(e),F.absY(t)))},u=function(){var e,r,o,a,f,l,p,v,m,g,y,b,E,S,x,N,C,L,D,P,H;switch(A){case"ProtocolVersion":if(j.rQlen()<12)return s("Incomplete protocol version");a=j.rQshiftStr(12).substr(4,7),Util.Info("Server ProtocolVersion: "+a);switch(a){case"003.003":O=3.3;break;case"003.006":O=3.3;break;case"003.007":O=3.7;break;case"003.008":O=3.8;break;case"004.000":O=3.8;break;default:return s("Invalid server version "+a)}O>M&&(O=M),tt||(R=setInterval(function(){j.flush()},50)),f="00"+parseInt(O,10)+".00"+O*10%10,j.send_string("RFB "+f+"\n"),i("Security","Sent ProtocolVersion: "+f);break;case"Security":if(O>=3.7){v=j.rQshift8();if(j.rQwait("security type",v,1))return!1;if(v===0)return e=j.rQshift32(),r=j.rQshiftStr(e),s("Security failure: "+r);_=0,p=j.rQshiftBytes(v),Util.Debug("Server security types: "+p);for(l=0;l<p.length;l+=1)p[l]>_&&p[l]<3&&(_=p[l]);if(_===0)return s("Unsupported security types: "+p);j.send([_])}else{if(j.rQwait("security scheme",4))return!1;_=j.rQshift32()}i("Authentication","Authenticating using scheme: "+_),u();break;case"Authentication":switch(_){case 0:if(j.rQwait("auth reason",4))return!1;return e=j.rQshift32(),r=j.rQshiftStr(e),s("Auth failure: "+r);case 1:if(O>=3.8){i("SecurityResult");return}break;case 2:if(k.length===0){i("password","Password Required"),n.onPasswordRequired(t);return}if(j.rQwait("auth challenge",16))return!1;m=j.rQshiftBytes(16),g=ft(k,m),j.send(g),i("SecurityResult");return;default:s("Unsupported auth scheme: "+_);return}i("ClientInitialisation","No auth required"),u();break;case"SecurityResult":if(j.rQwait("VNC auth response ",4))return!1;switch(j.rQshift32()){case 0:break;case 1:if(O>=3.8){o=j.rQshift32();if(j.rQwait("SecurityResult reason",o,8))return!1;r=j.rQshiftStr(o),s(r)}else s("Authentication failed");return;case 2:return s("Too many auth attempts")}i("ClientInitialisation","Authentication OK"),u();break;case"ClientInitialisation":j.send([n.shared?1:0]),i("ServerInitialisation","Authentication OK");break;case"ServerInitialisation":if(j.rQwait("server initialization",24))return!1;J=j.rQshift16(),K=j.rQshift16(),y=j.rQshift8(),b=j.rQshift8(),E=j.rQshift8(),P=j.rQshift8(),S=j.rQshift16(),x=j.rQshift16(),N=j.rQshift16(),C=j.rQshift8(),L=j.rQshift8(),D=j.rQshift8(),j.rQshiftStr(3),Util.Info("Screen: "+J+"x"+K+", bpp: "+y+", depth: "+b+", big_endian: "+E+", true_color: "+P+", red_max: "+S+", green_max: "+x+", blue_max: "+N+", red_shift: "+C+", green_shift: "+L+", blue_shift: "+D),E!==0&&Util.Warn("Server native endian is not little endian"),C!==16&&Util.Warn("Server native red-shift is not 16"),D!==0&&Util.Warn("Server native blue-shift is not 0"),H=j.rQshift32(),Q=j.rQshiftStr(H),n.true_color&&Q==="Intel(r) AMT KVM"&&(Util.Warn("Intel AMT KVM only support 8/16 bit depths. Disabling true color"),n.true_color=!1),F.set_true_color(n.true_color),F.resize(J,K),I.grab(),q.grab(),n.true_color?(V=4,$=3):(V=1,$=1),g=c(),g=g.concat(h()),g=g.concat(d()),et.fbu_rt_start=(new Date).getTime(),j.send(g),setTimeout(T,n.check_rate),setTimeout(w,G),n.encrypt?i("normal","Connected (encrypted) to: "+Q):i("normal","Connected (unencrypted) to: "+Q)}},a=function(){var e=!0,r,i,o,u,a,l,c,h,p;X.rects>0?r=0:r=j.rQshift8();switch(r){case 0:e=f();break;case 1:Util.Debug("SetColourMapEntries"),j.rQshift8(),a=j.rQshift16(),l=j.rQshift16();if(j.rQwait("SetColourMapEntries",l*6,6))return!1;for(u=0;u<l;u+=1)c=j.rQshift16(),c=parseInt(c/256,10),h=parseInt(j.rQshift16()/256,10),p=parseInt(j.rQshift16()/256,10),F.set_colourMap([p,h,c],a+u);Util.Debug("colourMap: "+F.get_colourMap()),Util.Info("Registered "+l+" colourMap entries");break;case 2:Util.Debug("Bell"),n.onBell(t);break;case 3:Util.Debug("ServerCutText");if(j.rQwait("ServerCutText header",7,1))return!1;j.rQshiftBytes(3),i=j.rQshift32();if(j.rQwait("ServerCutText",i,8))return!1;o=j.rQshiftStr(i),n.clipboardReceive(t,o),n.onClipboard(t,o);break;default:s("Disconnected: illegal server message type "+r),Util.Debug("ws.rQslice(0,30):"+j.rQslice(0,30))}return e},f=function(){var e,r,i,o=!0;if(X.rects===0){if(j.rQwait("FBU header",3))return j.rQunshift8(0),!1;j.rQshift8(),X.rects=j.rQshift16(),X.bytes=0,et.cur_fbu=0,et.fbu_rt_start>0&&(e=(new Date).getTime(),Util.Info("First FBU latency: "+(e-et.fbu_rt_start)))}while(X.rects>0){if(A!=="normal")return!1;if(j.rQwait("FBU",X.bytes))return!1;if(X.bytes===0){if(j.rQwait("rect header",12))return!1;r=j.rQshiftBytes(12),X.x=(r[0]<<8)+r[1],X.y=(r[2]<<8)+r[3],X.width=(r[4]<<8)+r[5],X.height=(r[6]<<8)+r[7],X.encoding=parseInt((r[8]<<24)+(r[9]<<16)+(r[10]<<8)+r[11],10),n.onFBUReceive(t,{x:X.x,y:X.y,width:X.width,height:X.height,encoding:X.encoding,encodingName:H[X.encoding]});if(!H[X.encoding])return s("Disconnected: unsupported encoding "+X.encoding),!1}et.last_fbu=(new Date).getTime(),o=P[X.encoding](),e=(new Date).getTime(),et.cur_fbu+=e-et.last_fbu,o&&(B[X.encoding][0]+=1,B[X.encoding][1]+=1,et.pixels+=X.width*X.height);if(X.rects===0||et.pixels>=J*K){if(X.width===J&&X.height===K||et.fbu_rt_start>0)et.full_fbu_total+=et.cur_fbu,et.full_fbu_cnt+=1,Util.Info("Timing of full FBU, cur: "+et.cur_fbu+", total: "+et.full_fbu_total+", cnt: "+et.full_fbu_cnt+", avg: "+et.full_fbu_total/et.full_fbu_cnt);et.fbu_rt_start>0&&(i=e-et.fbu_rt_start,et.fbu_rt_total+=i,et.fbu_rt_cnt+=1,Util.Info("full FBU round-trip, cur: "+i+", total: "+et.fbu_rt_total+", cnt: "+et.fbu_rt_cnt+", avg: "+et.fbu_rt_total/et.fbu_rt_cnt),et.fbu_rt_start=0)}if(!o)return o}return n.onFBUComplete(t,{x:X.x,y:X.y,width:X.width,height:X.height,encoding:X.encoding,encodingName:H[X.encoding]}),!0},P.RAW=function(){var t,n;return X.lines===0&&(X.lines=X.height),X.bytes=X.width*V,j.rQwait("RAW",X.bytes)?!1:(t=X.y+(X.height-X.lines),n=Math.min(X.lines,Math.floor(j.rQlen()/(X.width*V))),F.blitImage(X.x,t,X.width,n,j.get_rQ(),j.get_rQi()),j.rQshiftBytes(X.width*n*V),X.lines-=n,X.lines>0?X.bytes=X.width*V:(X.rects-=1,X.bytes=0),!0)},P.COPYRECT=function(){var t,n;return j.rQwait("COPYRECT",4)?!1:(t=j.rQshift16(),n=j.rQshift16(),F.copyImage(t,n,X.x,X.y,X.width,X.height),X.rects-=1,X.bytes=0,!0)},P.RRE=function(){var t,n,r,i,s,o;if(X.subrects===0){if(j.rQwait("RRE",4+V))return!1;X.subrects=j.rQshift32(),t=j.rQshiftBytes(V),F.fillRect(X.x,X.y,X.width,X.height,t)}while(X.subrects>0&&j.rQlen()>=V+8)t=j.rQshiftBytes(V),n=j.rQshift16(),r=j.rQshift16(),i=j.rQshift16(),s=j.rQshift16(),F.fillRect(X.x+n,X.y+r,i,s,t),X.subrects-=1;return X.subrects>0?(o=Math.min(Z,X.subrects),X.bytes=(V+8)*o):(X.rects-=1,X.bytes=0),!0},P.HEXTILE=function(){var t,n,r,i,o,u,a,f,l,c,h,p,d,v,m,g,y,b=j.get_rQ(),w=j.get_rQi();X.tiles===0&&(X.tiles_x=Math.ceil(X.width/16),X.tiles_y=Math.ceil(X.height/16),X.total_tiles=X.tiles_x*X.tiles_y,X.tiles=X.total_tiles);while(X.tiles>0){X.bytes=1;if(j.rQwait("HEXTILE subencoding",X.bytes))return!1;t=b[w];if(t>30)return s("Disconnected: illegal hextile subencoding "+t),!1;n=0,i=X.total_tiles-X.tiles,o=i%X.tiles_x,f=Math.floor(i/X.tiles_x),u=X.x+o*16,l=X.y+f*16,a=Math.min(16,X.x+X.width-u),c=Math.min(16,X.y+X.height-l);if(t&1)X.bytes+=a*c*V;else{t&2&&(X.bytes+=V),t&4&&(X.bytes+=V);if(t&8){X.bytes+=1;if(j.rQwait("hextile subrects header",X.bytes))return!1;n=b[w+X.bytes-1],t&16?X.bytes+=n*(V+2):X.bytes+=n*2}}if(j.rQwait("hextile",X.bytes))return!1;X.subencoding=b[w],w+=1;if(X.subencoding===0)X.lastsubencoding&1?Util.Debug("     Ignoring blank after RAW"):F.fillRect(u,l,a,c,X.background);else if(X.subencoding&1)F.blitImage(u,l,a,c,b,w),w+=X.bytes-1;else{X.subencoding&2&&(X.background=b.slice(w,w+V),w+=V),X.subencoding&4&&(X.foreground=b.slice(w,w+V),w+=V),F.startTile(u,l,a,c,X.background);if(X.subencoding&8){n=b[w],w+=1;for(p=0;p<n;p+=1)X.subencoding&16?(r=b.slice(w,w+V),w+=V):r=X.foreground,h=b[w],w+=1,d=h>>4,v=h&15,m=b[w],w+=1,g=(m>>4)+1,y=(m&15)+1,F.subTile(d,v,g,y,r)}F.finishTile()}j.set_rQi(w),X.lastsubencoding=X.subencoding,X.bytes=0,X.tiles-=1}return X.tiles===0&&(X.rects-=1),!0},y=function(e){var t=1,n=0;return n+=e[0]&127,e[0]&128&&(t+=1,n+=(e[1]&127)<<7,e[1]&128&&(t+=1,n+=e[2]<<14)),[t,n]},b=function(e){return";base64,"+Base64.encode(e)},w=function(){var e,t,n;n=F.get_context();if(A==="normal"){t=X.imgQ;while(t.length>0&&t[0].img.complete)e=t.shift(),e.type==="fill"?F.fillRect(e.x,e.y,e.width,e.height,e.color):e.type==="rgb"?F.blitRgbImage(e.x,e.y,e.width,e.height,e.img.data,0):n.drawImage(e.img,e.x,e.y);setTimeout(w,G)}},P.TIGHT=function(){return ct(!1)},P.TIGHT_PNG=function(){return ct(!0)},P.last_rect=function(){return Util.Debug(">> set_desktopsize"),X.rects=0,Util.Debug("<< set_desktopsize"),!0},P.DesktopSize=function(){return Util.Debug(">> set_desktopsize"),J=X.width,K=X.height,F.resize(J,K),et.fbu_rt_start=(new Date).getTime(),j.send(d()),X.bytes=0,X.rects-=1,Util.Debug("<< set_desktopsize"),!0},P.Cursor=function(){var t,n,r,i,s,o;return t=X.x,n=X.y,r=X.width,i=X.height,s=r*i*V,o=Math.floor((r+7)/8)*i,X.bytes=s+o,j.rQwait("cursor encoding",X.bytes)?!1:(F.changeCursor(j.rQshiftBytes(s),j.rQshiftBytes(o),t,n,r,i),X.bytes=0,X.rects-=1,!0)},P.JPEG_quality_lo=function(){Util.Error("Server sent jpeg_quality pseudo-encoding")},P.compress_lo=function(){Util.Error("Server sent compress level pseudo-encoding")},c=function(){var e;return e=[0],e.push8(0),e.push8(0),e.push8(0),e.push8(V*8),e.push8($*8),e.push8(0),e.push8(n.true_color?1:0),e.push16(255),e.push16(255),e.push16(255),e.push8(16),e.push8(8),e.push8(0),e.push8(0),e.push8(0),e.push8(0),e},h=function(){var e,t,r=[];for(t=0;t<D.length;t+=1)D[t][0]==="Cursor"&&!n.local_cursor?Util.Debug("Skipping Cursor pseudo-encoding"):r.push(D[t][1]);e=[2],e.push8(0),e.push16(r.length);for(t=0;t<r.length;t+=1)e.push32(r[t]);return e},p=function(e,t,n,r,i){typeof t=="undefined"&&(t=0),typeof n=="undefined"&&(n=0),typeof r=="undefined"&&(r=J),typeof i=="undefined"&&(i=K);var s;return s=[3],s.push8(e),s.push16(t),s.push16(n),s.push16(r),s.push16(i),s},d=function(){var e=F.getCleanDirtyReset(),t=[],n,r,i;r=e.cleanBox,r.w>0&&r.h>0&&(t=t.concat(p(1,r.x,r.y,r.w,r.h)));for(n=0;n<e.dirtyBoxes.length;n++)i=e.dirtyBoxes[n],t=t.concat(p(0,i.x,i.y,i.w,i.h));return t},v=function(e,t){var n;return n=[4],n.push8(t),n.push16(0),n.push32(e),n},m=function(e,t){var n;return n=[5],n.push8(rt),n.push16(e),n.push16(t),n},g=function(e){var t,n,r;t=[6],t.push8(0),t.push8(0),t.push8(0),t.push32(e.length),r=e.length;for(n=0;n<r;n+=1)t.push(e.charCodeAt(n));return t},t.connect=function(e,t,n,r){N=e,C=t,k=n!==undefined?n:"",L=r!==undefined?r:"";if(!N||!C)return s("Must set host and port");i("connect")},t.disconnect=function(){i("disconnect","Disconnecting")},t.sendPassword=function(e){k=e,A="Authentication",setTimeout(u,1)},t.sendCtrlAltDel=function(){if(A!=="normal"||n.view_only)return!1;Util.Info("Sending Ctrl-Alt-Del");var e=[];e=e.concat(v(65507,1)),e=e.concat(v(65513,1)),e=e.concat(v(65535,1)),e=e.concat(v(65535,0)),e=e.concat(v(65513,0)),e=e.concat(v(65507,0)),e=e.concat(d()),j.send(e)},t.sendKey=function(e,t){if(A!=="normal"||n.view_only)return!1;var r=[];typeof t!="undefined"?(Util.Info("Sending key code ("+(t?"down":"up")+"): "+e),r=r.concat(v(e,t?1:0))):(Util.Info("Sending key code (down + up): "+e),r=r.concat(v(e,1)),r=r.concat(v(e,0))),r=r.concat(d()),j.send(r)},t.clipboardPasteFrom=function(e){if(A!=="normal")return;j.send(g(e))},t.testMode=function(e){tt=!0,t.recv_message=j.testMode(e),T=function(){},t.connect=function(e,t,n){N=e,C=t,k=n,i("ProtocolVersion","Starting VNC handshake")}},ut()};